Hooks:PostHook( HUDManager , "_player_hud_layout" , "DynamicCrosshairsPostHUDManagerPlayerInfoHUDLayout" , function( self )

	self._crosshair_main = managers.hud:script( PlayerBase.PLAYER_INFO_HUD_PD2 ).panel:panel({
		name 	= "crosshair_main",
		halign 	= "grow",
		valign 	= "grow"
	})
	
	local crosshair_panel = self._crosshair_main:panel({
		name = "crosshair_panel"
	})

	local interact_crosshair_panel = self._crosshair_main:panel({
		name 	= "interact_crosshair_panel",
		visible = false
	})

	local dot_crosshair_panel = self._crosshair_main:panel({
		name 	= "dot_crosshair_panel",
		visible = false
	})

	interact_crosshair_panel:set_center( managers.hud:script( PlayerBase.PLAYER_INFO_HUD_PD2 ).panel:center() )
	dot_crosshair_panel:set_center( managers.hud:script( PlayerBase.PLAYER_INFO_HUD_PD2 ).panel:center() )

	self._interact_crosshair = interact_crosshair_panel:bitmap({
		name 			= "interact_crosshair",
		texture 		= "guis/textures/interact_crosshair",
		w 				= 50,
		h 				= 50,
		rotation 		= -45,
		color 			= Color( 18 / 255 , 255 / 255 , 21 / 255 ),
		layer 			= 2
	})

	self._dot_crosshair = dot_crosshair_panel:bitmap({
		name 			= "dot_crosshair",
		texture 		= "guis/textures/crosshair_dot",
		w 				= 5,
		h 				= 5,
		layer 			= 2
	})

	self._interact_crosshair:set_center( interact_crosshair_panel:center() )
	self._dot_crosshair:set_center( dot_crosshair_panel:center() )

	local rot = 0
	self._crosshair_parts = {}
	for i = 1 , 4 do
		self._crosshair_parts[ i ] = {}

		self._crosshair_parts[ i ][ 1 ] = crosshair_panel:bitmap({
			name 			= "crosshair_part_bottom",
			texture 		= "guis/textures/hud_icons",
			texture_rect 	= {
								481,
								33,
								23,
								4
							},
			layer 			= 2,
			rotation 		= rot,
			valign 			= "scale",
			halign 			= "scale"
		})
		self._crosshair_parts[ i ][ 2 ] = crosshair_panel:bitmap({
			name 			= "crosshair_part_bottom",
			texture 		= "guis/textures/hud_icons",
			texture_rect 	= {
								481,
								33,
								23,
								4
							},
			layer 			= 2,
			rotation 		= rot + 180,
			valign 			= "scale",
			halign 			= "scale"
		})

		rot = rot + 90
	end
	
	crosshair_panel:set_center( managers.hud:script( PlayerBase.PLAYER_INFO_HUD_PD2 ).panel:center() )
	
	self:set_crosshair_offset( tweak_data.weapon.crosshair.DEFAULT_OFFSET )
	self._ch_current_offset = self._ch_offset
	self:_layout_crosshair()

end )

function HUDManager:set_crosshair_color( color )

	if not self._crosshair_main then return end

	for _ , s in pairs( self._crosshair_parts ) do
		for _ , part in pairs( s ) do
			part:set_color( color )
		end
	end
	self._dot_crosshair:set_color( color )

end

function HUDManager:show_crosshair_panel( visible )

	if not self._crosshair_main then return end
	
	self._crosshair_main:set_visible( visible )

end

function HUDManager:set_crosshair_offset( offset )

	self._ch_offset = math.lerp( tweak_data.weapon.crosshair.MIN_OFFSET , tweak_data.weapon.crosshair.MAX_OFFSET , offset )
	
end

function HUDManager:set_crosshair_visible( visible )

	if not self._crosshair_main then return end

	if self._crosshair_main:child( "interact_crosshair_panel" ):visible() then
		return
	end

	if visible then
		self:set_dot_crosshair_visible( false )
		self._crosshair_main:child( "crosshair_panel" ):set_visible( true )

		self._crosshair_main:child( "crosshair_panel" ):stop()
		self._crosshair_main:child( "crosshair_panel" ):animate( function( o )
			over( self._anim_time or 0.5 , function( p )
				self._crosshair_main:child( "crosshair_panel" ):set_alpha( math.lerp( self._crosshair_main:child( "crosshair_panel" ):alpha() , 1 , p ) )
				self._anim_time = p
			end )
			self._anim_time = nil
		end )
	elseif not visible and self._crosshair_main:child( "crosshair_panel" ):visible() then
		self._crosshair_main:child( "crosshair_panel" ):stop()
		self._crosshair_main:child( "crosshair_panel" ):animate( function( o )
			over( self._anim_time or 0.5 , function( p )
				self._crosshair_main:child( "crosshair_panel" ):set_alpha( math.lerp( self._crosshair_main:child( "crosshair_panel" ):alpha() , 0 , p ) )
				self._anim_time = p
			end )
			self._crosshair_main:child( "crosshair_panel" ):set_visible( false )
			self._anim_time = nil
		end )
	end

end

function HUDManager:set_dot_crosshair_visible( visible )

	if not self._crosshair_main then return end

	if self._crosshair_main:child( "interact_crosshair_panel" ):visible() then
		return
	end

	if visible then
		self._crosshair_main:child( "dot_crosshair_panel" ):set_visible( true )
	elseif not visible and self._crosshair_main:child( "dot_crosshair_panel" ):visible() then
		self._crosshair_main:child( "dot_crosshair_panel" ):set_visible( false )
	end

end

function HUDManager:set_interact_crosshair_visible( visible )

	if not self._crosshair_main then return end
	
	if visible then
		if self._crosshair_main:child( "crosshair_panel" ):visible() then
			self:set_crosshair_visible( false )
		end
		if self._crosshair_main:child( "dot_crosshair_panel" ):visible() then
			self:set_dot_crosshair_visible( false )
		end

		self._crosshair_main:child( "interact_crosshair_panel" ):set_visible( true )

		self._crosshair_main:child( "interact_crosshair_panel" ):stop()
		self._crosshair_main:child( "interact_crosshair_panel" ):animate( function( o )
			over( self._anim_time or 0.5 , function( p )
				self._interact_crosshair:set_rotation( math.lerp( self._interact_crosshair:rotation() , 0 , p ) )
				self._interact_crosshair:set_alpha( math.lerp( self._interact_crosshair:alpha() , 1 , p ) )
				self._anim_time = p
			end )
			self._anim_time = nil
		end )
	elseif not visible and self._crosshair_main:child( "interact_crosshair_panel" ):visible() then
		self._crosshair_main:child( "interact_crosshair_panel" ):stop()
		self._crosshair_main:child( "interact_crosshair_panel" ):animate( function( o )
			over( self._anim_time or 0.5 , function( p )
				self._interact_crosshair:set_rotation( math.lerp( self._interact_crosshair:rotation() , -45 , p ) )
				self._interact_crosshair:set_alpha( math.lerp( self._interact_crosshair:alpha() , 0 , p ) )
				self._anim_time = p
			end )
			self._crosshair_main:child( "interact_crosshair_panel" ):set_visible( false )
			self._anim_time = nil
		end )
	end

end

function HUDManager:_update_crosshair_offset( t, dt )

	if self._ch_current_offset and self._ch_current_offset > self._ch_offset then
		self:_kick_crosshair_offset( -dt * 3 )
		if self._ch_current_offset < self._ch_offset then
			self._ch_current_offset = self._ch_offset
			self:_layout_crosshair()
		end

	elseif self._ch_current_offset and self._ch_current_offset < self._ch_offset then
		self:_kick_crosshair_offset( dt * 3 )
		if self._ch_current_offset > self._ch_offset then
			self._ch_current_offset = self._ch_offset
			self:_layout_crosshair()
		end

	end
	
end

function HUDManager:_kick_crosshair_offset( offset )

	self._ch_current_offset = self._ch_current_offset or 0
	if self._ch_current_offset > tweak_data.weapon.crosshair.MAX_OFFSET then
		self._ch_current_offset = tweak_data.weapon.crosshair.MAX_OFFSET
	end

	self._ch_current_offset = self._ch_current_offset + math.lerp( tweak_data.weapon.crosshair.MIN_KICK_OFFSET , tweak_data.weapon.crosshair.MAX_KICK_OFFSET , offset )
	self:_layout_crosshair()
	
end

function HUDManager:_layout_crosshair()

	if not self._crosshair_main then return end
	
	local hud = self._crosshair_main
	local x = self._crosshair_main:child( "crosshair_panel" ):center_x() - self._crosshair_main:child( "crosshair_panel" ):left()
	local y = self._crosshair_main:child( "crosshair_panel" ):center_y() - self._crosshair_main:child( "crosshair_panel" ):top()

	for _ , s in pairs( self._crosshair_parts ) do
		local r1 = s[ 1 ]:rotation()
		s[ 1 ]:set_center_x( x + math.cos( r1 ) * self._ch_current_offset * tweak_data.scale.hud_crosshair_offset_multiplier )
		s[ 1 ]:set_center_y( y + math.sin( r1 ) * self._ch_current_offset * tweak_data.scale.hud_crosshair_offset_multiplier )

		local r2 = s[ 2 ]:rotation() + ( ( r1 == 0 or r1 == 180 ) and -90 or 90 )
		s[ 2 ]:set_center_x( x + math.sin( r2 ) * self._ch_current_offset * tweak_data.scale.hud_crosshair_offset_multiplier )
		s[ 2 ]:set_center_y( y + math.cos( r2 ) * self._ch_current_offset * tweak_data.scale.hud_crosshair_offset_multiplier )
	end

end