Hooks:PostHook( PlayerStandard , "update" , "DynamicCrosshairsPostPlayerStandardUpdate" , function( self , t , dt )
	
	if self:_is_meleeing() or self:_interacting() or self:in_steelsight() then
		managers.hud:set_crosshair_visible( false )
		if self:_is_meleeing() then
			managers.hud:set_dot_crosshair_visible( true )
		end
	else
		managers.hud:set_crosshair_visible( true )
	end

	if self._fwd_ray and self._fwd_ray.unit then
	
		local unit = self._fwd_ray.unit
		
		local function is_teammate( unit )
			for _ , u_data in pairs( managers.groupai:state():all_criminals() ) do
				if u_data.unit == unit then return true end
			end
		end

		if managers.enemy:is_enemy( unit ) then
			managers.hud:set_crosshair_color( Color( 255 / 255 , 67 / 255 , 42 / 255 ) )
		else
			managers.hud:set_crosshair_color( Color( 18 / 255 , 255 / 255 , 21 / 255 ) )
		end
		
	else
	
		managers.hud:set_crosshair_color( Color( 18 / 255 , 255 / 255 , 21 / 255 ) )
		
	end

end )

function PlayerStandard:_update_crosshair_offset( t )
	
	if not alive( self._equipped_unit ) then
		return
	end
	
	local name_id = self._equipped_unit:base():get_name_id()
	if not tweak_data.weapon[ name_id ].crosshair then
		tweak_data.weapon[ name_id ].crosshair = deep_clone( tweak_data.weapon.glock_17.crosshair )
		return
	end
	
	if self._state_data.in_steelsight then
		managers.hud:set_crosshair_visible( not tweak_data.weapon[ name_id ].crosshair.steelsight.hidden )
		managers.hud:set_crosshair_offset( tweak_data.weapon[ name_id ].crosshair.steelsight.offset )
		return
	end
	
	local spread_multiplier = self._equipped_unit:base():spread_multiplier()
	managers.hud:set_crosshair_visible( not tweak_data.weapon[ name_id ].crosshair[ self._state_data.ducking and "crouching" or "standing" ].hidden )
	
	if self._moving then
		managers.hud:set_crosshair_offset( tweak_data.weapon[ name_id ].crosshair[ self._state_data.ducking and "crouching" or "standing" ].moving_offset * spread_multiplier )
		return
	else
		managers.hud:set_crosshair_offset( tweak_data.weapon[ name_id ].crosshair[ self._state_data.ducking and "crouching" or "standing" ].offset * spread_multiplier )
	end
	
end